-- write out that we loaded sucessfully (more or less, anyway)
io.write("Starting script for Level11 in BlinkenLUA / ",_VERSION,"!\n")

-- declare some global variables
GFX_DOOR_CLOSED = -1;
GFX_DOOR_OPEN = -1;

OBJ_DOOR1 = -1;
OBJ_DOOR2 = -1;

door1open = 0;
door2open = 0;

-- Required function: Initializing the level
function initLevel ()
    -- preload all gfx (on-the-fly loading is NOT recommended)
    GFX_DOOR_CLOSED = LoadGFX("fg_door_closed.bmp");
    GFX_DOOR_OPEN = LoadGFX("fg_door_open.bmp");
    
    -- create doors
    OBJ_DOOR1 = AddObject(GFX_DOOR_CLOSED, 27, 6, 1, 1, 1, 0);
    OBJ_DOOR2 = AddObject(GFX_DOOR_CLOSED, 68, 7, 1, 1, 1, 0);

    -- load extra sound
    SND_DOOR_OPEN = LoadSoundFX("fx_open_door.ogg");
end

-- Required function: Physics-loop for scripting part
function scriptPhysics ()
    --Count collectet pixels and open doors if enough pixels are collected
    if GetCollectedPixelCount()>41 then
        openDoor1();
    end

    if GetCollectedPixelCount()>24 then
        openDoor2();
    end
    
end

function handleAction (obj_id)
    --not needed
end

-- Script-internal functions
function openDoor1()
    if door1open == 0 then
        door1open = 1;
    
        -- exchange GFX for door
        SetGFX(OBJ_DOOR1, GFX_DOOR_OPEN);

       -- make door nonblocking
       SetBlocking(OBJ_DOOR1, 0);

       -- play sound
       PlaySoundFX(SND_DOOR_OPEN);
   end
end

function openDoor2()
    if door2open == 0 then
        door2open = 1;
    
        -- exchange GFX for door
        SetGFX(OBJ_DOOR2, GFX_DOOR_OPEN);

       -- make door nonblocking
       SetBlocking(OBJ_DOOR2, 0);

       -- play sound
       PlaySoundFX(SND_DOOR_OPEN);
    end
end
