-- write out that we loaded sucessfully (more or less, anyway)
io.write("Starting script for Level12 in BlinkenLUA / ",_VERSION,"!\n")

-- declare some global variables
GFX_WALL_TILE = -1;
OBJ_WALL_TILE = -1;

GFX_DOOR_CLOSED = -1;
GFX_DOOR_OPEN = -1;
SND_DOOR_OPEN = -1;

SND_BEAM = -1;

OBJ_DOOR1 = -1;
OBJ_DOOR2 = -1;
OBJ_DOOR3 = -1;
OBJ_DOOR4 = -1;
OBJ_DOOR5 = -1;
OBJ_DOOR6 = -1;
OBJ_DOOR7 = -1;
OBJ_DOOR8 = -1;

door1open = 0;
door2open = 0;
door3open = 0;
door4open = 0;
door5open = 0;
door6open = 0;
door7open = 0;
door8open = 0;

-- Required function: Initializing the level
function initLevel ()
    -- preload all gfx (on-the-fly loading is NOT recommended)
    GFX_DOOR_CLOSED = LoadGFX("fg_door_closed.bmp");
    GFX_DOOR_OPEN = LoadGFX("fg_door_open.bmp");

    GFX_WALL_TILE = LoadGFX("wall_tile.bmp");

    -- create doors
    OBJ_DOOR1 = AddObject(GFX_DOOR_CLOSED, 59, 10, 1, 1, 1, 0);
    OBJ_DOOR2 = AddObject(GFX_DOOR_CLOSED, 69, 2, 1, 1, 1, 0);
    OBJ_DOOR3 = AddObject(GFX_DOOR_CLOSED, 24, 6, 1, 1, 1, 0);
    OBJ_DOOR4 = AddObject(GFX_DOOR_CLOSED, 24, 11, 1, 1, 1, 0);
    OBJ_DOOR5 = AddObject(GFX_DOOR_CLOSED, 25, 17, 1, 1, 1, 0);
    OBJ_DOOR6 = AddObject(GFX_DOOR_CLOSED, 45, 25, 1, 1, 1, 0);
    OBJ_DOOR7 = AddObject(GFX_DOOR_CLOSED, 96, 24, 1, 1, 1, 0);
    OBJ_DOOR8 = AddObject(GFX_DOOR_CLOSED, 45, 33, 1, 1, 1, 0);
    
    -- create Walls (visible but not blocking)
    OBJ_WALL_TILE = AddObject(GFX_WALL_TILE, 105, 19, 0, 1, 1, 0);
    OBJ_WALL_TILE = AddObject(GFX_WALL_TILE, 104, 13, 0, 1, 1, 0);

    -- load extra sound
    SND_DOOR_OPEN = LoadSoundFX("fx_open_door.ogg");
    SND_BEAM = LoadSoundFX("fx_kill_monster.ogg"); -- TODO add better ogg for this
end

-- Required function: Physics-loop for scripting part
function scriptPhysics ()
    --Count collectet pixels and open doors if enough pixels are collected
    if GetCollectedPixelCount()>5 then
        openDoor1();
    end
	
    if GetCollectedPixelCount()>23 then
        openDoor2();
    end

    if GetCollectedPixelCount()>32 then
        openDoor3();
    end

    if GetCollectedPixelCount()>34 then
        openDoor4();
    end

    if GetCollectedPixelCount()>51 then
        openDoor5();
    end

    if GetCollectedPixelCount()>55 then
        openDoor6();
    end
    
    if GetCollectedPixelCount()>73 then
        openDoor7();
    end

    if GetCollectedPixelCount()>91 then
        openDoor8();
    end

    -- Handle beaming
    if GetPlayerX()>4000 then
        PlaySoundFX(SND_BEAM);
        if door8open == 1 then
            SetPlayerX(1760);
            SetPlayerY(1024);        
        elseif door7open == 1 then 
            SetPlayerX(3032);
            SetPlayerY(1056);
        elseif door6open == 1 then 
            SetPlayerX(1056);
            SetPlayerY(576);
        else
            SetPlayerX(2304);
            SetPlayerY(32);
        end
    end    
    
end

function handleAction (obj_id)
    --not needed
end

-- Script-internal functions
function openDoor1()
    if door1open == 0 then
        door1open = 1;
    
        -- exchange GFX for door
        SetGFX(OBJ_DOOR1, GFX_DOOR_OPEN);

       -- make door nonblocking
       SetBlocking(OBJ_DOOR1, 0);

       -- play sound
       PlaySoundFX(SND_DOOR_OPEN);
   end
end

function openDoor2()
    if door2open == 0 then
        door2open = 1;
    
        -- exchange GFX for door
        SetGFX(OBJ_DOOR2, GFX_DOOR_OPEN);

       -- make door nonblocking
       SetBlocking(OBJ_DOOR2, 0);

       -- play sound
       PlaySoundFX(SND_DOOR_OPEN);
    end
end

function openDoor3()
    if door3open == 0 then
        door3open = 1;
    
        -- exchange GFX for door
        SetGFX(OBJ_DOOR3, GFX_DOOR_OPEN);

       -- make door nonblocking
       SetBlocking(OBJ_DOOR3, 0);

       -- play sound
       PlaySoundFX(SND_DOOR_OPEN);
   end
end

function openDoor4()
    if door4open == 0 then
        door4open = 1;
    
        -- exchange GFX for door
        SetGFX(OBJ_DOOR4, GFX_DOOR_OPEN);

       -- make door nonblocking
       SetBlocking(OBJ_DOOR4, 0);

       -- play sound
       PlaySoundFX(SND_DOOR_OPEN);
    end
end

function openDoor5()
    if door5open == 0 then
        door5open = 1;
    
        -- exchange GFX for door
        SetGFX(OBJ_DOOR5, GFX_DOOR_OPEN);

       -- make door nonblocking
       SetBlocking(OBJ_DOOR5, 0);

       -- play sound
       PlaySoundFX(SND_DOOR_OPEN);
   end
end

function openDoor6()
    if door6open == 0 then
        door6open = 1;
    
        -- exchange GFX for door
        SetGFX(OBJ_DOOR6, GFX_DOOR_OPEN);

       -- make door nonblocking
       SetBlocking(OBJ_DOOR6, 0);

       -- play sound
       PlaySoundFX(SND_DOOR_OPEN);
    end
end

function openDoor7()
    if door7open == 0 then
        door7open = 1;
    
        -- exchange GFX for door
        SetGFX(OBJ_DOOR7, GFX_DOOR_OPEN);

       -- make door nonblocking
       SetBlocking(OBJ_DOOR7, 0);

       -- play sound
       PlaySoundFX(SND_DOOR_OPEN);
   end
end

function openDoor8()
    if door8open == 0 then
        door8open = 1;
    
        -- exchange GFX for door
        SetGFX(OBJ_DOOR8, GFX_DOOR_OPEN);

       -- make door nonblocking
       SetBlocking(OBJ_DOOR8, 0);

       -- play sound
       PlaySoundFX(SND_DOOR_OPEN);
    end
end
