-- write out that we loaded sucessfully (more or less, anyway)
io.write("Starting script for Level: Desert 1 in BlinkenLUA / ",_VERSION,"!\n");

-- declare some global variables
GFX_WALL_TILE = -1;
OBJ_WALL_TILE = -1;

GFX_DOOR_CLOSED = -1;
GFX_DOOR_OPEN = -1;

GFX_SWITCH_RED = -1;
GFX_SWITCH_GREEN = -1;

OBJ_SWITCH_A = -1;
OBJ_SWITCH_B = -1;
OBJ_SWITCH_C = -1;

OBJ_WALL_TILE_A = -1;
OBJ_WALL_TILE_B = -1;
OBJ_WALL_TILE_C = -1;

OBJ_DOOR1 = -1;

SND_BEAM = -1;
SND_DOOR_OPEN = -1;
SND_DOOR_CLOSED = -1;

raetsel_stage = 0;
switch_a_on = 0;
switch_b_on = 0;
switch_c_on = 0;
raetsel_abort_delay = 0;

door1open = 0;



-- Required function: Initializing the level
function initLevel ()
    -- preload all gfx (on-the-fly loading is NOT recommended)
    GFX_DOOR_CLOSED = LoadGFX("fg_door_closed.bmp");
    GFX_DOOR_OPEN = LoadGFX("fg_door_open.bmp");

    GFX_WALL_TILE = LoadGFX("wall_tile.bmp");

    GFX_SWITCH_RED = LoadGFX("fg_switch_red.bmp");
    GFX_SWITCH_GREEN = LoadGFX("fg_switch_green.bmp");

    -- create door TODO Am Ausgang positionieren
    OBJ_DOOR1 = AddObject(GFX_DOOR_CLOSED, 441, 56, 1, 1, 1, 0);

    -- create Switches
    OBJ_SWITCH_A = AddObject(GFX_SWITCH_RED, 369, 37, 0, 1, 0, 0);
    OBJ_SWITCH_B = AddObject(GFX_SWITCH_RED, 371, 37, 0, 1, 0, 0);
    OBJ_SWITCH_C = AddObject(GFX_SWITCH_RED, 373, 37, 0, 1, 0, 0);

    -- create raetsel-tiles
    OBJ_WALL_TILE_A = AddObject(GFX_WALL_TILE, 377, 36, 0, 0, 0, 0);
    OBJ_WALL_TILE_B = AddObject(GFX_WALL_TILE, 381, 34, 0, 0, 0, 0);
    OBJ_WALL_TILE_C = AddObject(GFX_WALL_TILE, 384, 32, 0, 0, 0, 0);

    -- load extra sound
    SND_DOOR_OPEN = LoadSoundFX("fx_open_door.ogg");
    SND_DOOR_CLOSE = LoadSoundFX("fx_open_door.ogg"); -- TODO add better ogg for this
    SND_BEAM = LoadSoundFX("fx_kill_monster.ogg"); -- TODO add better ogg for this
end



-- Required function: Physics-loop for scripting part
function scriptPhysics ()
    -- Handle beaming
    -- von gruft 1 (61/136) zu pyramiedenspitze (ca z9/s150)
    if GetPlayerX()>4310 and GetPlayerX()<4330 and GetPlayerY()>1910 and GetPlayerY()<1934 then
        PlaySoundFX(SND_BEAM);
        SetPlayerX(4767);
        SetPlayerY(254);
    end

    -- von pyramiedenspitze (20/140-160) zureuck vor gruft 1 (60/129)
    if GetPlayerX()>4438 and GetPlayerX()<5100 and GetPlayerY()>590 and GetPlayerY()<620 then
        PlaySoundFX(SND_BEAM);
        SetPlayerX(4098);
        SetPlayerY(1845);
    end


    -- TODO von zweiter Königskamer (66/144) nach ganz links oben (8/10)
    if GetPlayerX()>4570 and GetPlayerX()<4590 and GetPlayerY()>2070 and GetPlayerY()<2095 then
        PlaySoundFX(SND_BEAM);
        SetPlayerX(255);
        SetPlayerY(255);
    end

    -- TODO von ganz links oben (45/1) nach ganz rechts oben zum raetsel (35/372)
    if GetPlayerX()<20 and GetPlayerY()>1300 then
        PlaySoundFX(SND_BEAM);
        SetPlayerX(11872);
        SetPlayerY(1103);
    end

    -- handle raetsel_abort_delay if needed
    if raetsel_abort_delay > 0 then
        if raetsel_abort_delay == 1 then
            reset_raetsel();
        else
            raetsel_abort_delay=raetsel_abort_delay-1;
        end
    end

    -- oeffne Ausgang wenn alle Pixel gesammelt wurden
    if  GetCanExit() == 1 and door1open == 0 then
        door1open=1;
        SetGFX(OBJ_DOOR1, GFX_DOOR_OPEN);
        SetBlocking(OBJ_DOOR1, 0);
        PlaySoundFX(SND_DOOR_OPEN);
    end
end



function handleAction (obj_id)
    -- Raetsel (l, _r, r, _m, _l)
    if obj_id == OBJ_SWITCH_A then
        toggle_switch_a();
        if raetsel_stage == 0 then
            set_raetsel_stage(1);
        else
            if raetsel_stage == 4 then
                set_raetsel_stage(5);
            else
                set_raetsel_stage(-1);
            end
        end
    end
    if obj_id == OBJ_SWITCH_B then
        toggle_switch_b();
        if raetsel_stage == 3 then
            set_raetsel_stage(4);
        else
            set_raetsel_stage(-1);
        end
    end
    if obj_id == OBJ_SWITCH_C then
        toggle_switch_c();
        if raetsel_stage == 1 then
            set_raetsel_stage(2);
        else
            if raetsel_stage == 2 then
                set_raetsel_stage(3);
            else
                set_raetsel_stage(-1);
            end
        end
    end
end



-- Script-internal functions
function toggle_switch_a()
    if switch_a_on == 0 then
        SetGFX(OBJ_SWITCH_A, GFX_SWITCH_GREEN);
        PlaySoundFX(SND_DOOR_OPEN);
        switch_a_on = 1;
    else
        SetGFX(OBJ_SWITCH_A, GFX_SWITCH_RED);
        PlaySoundFX(SND_DOOR_CLOSED);
        switch_a_on = 0;
    end
end

function toggle_switch_b()
    if switch_b_on == 0 then
        SetGFX(OBJ_SWITCH_B, GFX_SWITCH_GREEN);
        PlaySoundFX(SND_DOOR_OPEN);
        switch_b_on = 1;
    else
        SetGFX(OBJ_SWITCH_B, GFX_SWITCH_RED);
        PlaySoundFX(SND_DOOR_CLOSED);
        switch_b_on = 0;
    end
end

function toggle_switch_c()
    if switch_c_on == 0 then
        SetGFX(OBJ_SWITCH_C, GFX_SWITCH_GREEN);
        PlaySoundFX(SND_DOOR_OPEN);
        switch_c_on = 1;
    else
        SetGFX(OBJ_SWITCH_C, GFX_SWITCH_RED);
        PlaySoundFX(SND_DOOR_CLOSED);
        switch_c_on = 0;
    end
end


function set_raetsel_stage(s)
    raetsel_stage = s;
    if s == -1 then
        raetsel_abort_delay=50;
    else
        if s == 2 then
            raetsel_tile_a();
        end
        if s == 4 then
            raetsel_tile_b();
        end
        if s == 5 then
            raetsel_tile_c();
            raetsel_abort_delay=650;
        end
    end
end


function raetsel_tile_a()
    SetVisible(OBJ_WALL_TILE_A, 1);
    SetBlocking(OBJ_WALL_TILE_A, 1);
end

function raetsel_tile_b()
    SetVisible(OBJ_WALL_TILE_B, 1);
    SetBlocking(OBJ_WALL_TILE_B, 1);
end

function raetsel_tile_c()
    SetVisible(OBJ_WALL_TILE_C, 1);
    SetBlocking(OBJ_WALL_TILE_C, 1);
end


function reset_raetsel()
    SetGFX(OBJ_SWITCH_A, GFX_SWITCH_RED);
    SetGFX(OBJ_SWITCH_B, GFX_SWITCH_RED);
    SetGFX(OBJ_SWITCH_C, GFX_SWITCH_RED);
    SetVisible(OBJ_WALL_TILE_A, 0)
    SetBlocking(OBJ_WALL_TILE_A, 0);
    SetVisible(OBJ_WALL_TILE_B, 0)
    SetBlocking(OBJ_WALL_TILE_B, 0);
    SetVisible(OBJ_WALL_TILE_C, 0)
    SetBlocking(OBJ_WALL_TILE_C, 0);
    PlaySoundFX(SND_DOOR_CLOSED);
    raetsel_stage = 0;
    switch_a_on = 0;
    switch_b_on = 0;
    switch_c_on = 0;
    raetsel_abort_delay = 0;
end
