-- Exercise scripting a bit in our test-level

-- write out that we loaded sucessfully (mor or less, anyway)
io.write("Starting script for Level0 in BlinkenLUA / ",_VERSION,"!\n")

-- declare some global variables
GFX_DOOR_CLOSED = -1;
GFX_DOOR_OPEN = -1;
GFX_SWITCH_RED = -1;
GFX_SWITCH_GREEN = -1;
OBJ_DOOR = -1;
OBJ_SWITCH = -1;
SND_DOOR_OPEN = -1;
SND_DOOR_CLOSE = -1;
GFX_ELEVATOR = {};
OBJ_ELEVATOR = 0;
switchon = 0;
timer = 0;
ELEVATOR_TIMER = 0;
ELEVATOR_POS = 220;
ELEVATOR_DIR = 1;

-- Required function: Initializing the level
function initLevel ()
    -- preload all gfx (on-the-fly loading is NOT recommended)
    GFX_DOOR_CLOSED = LoadGFX("fg_door_closed.bmp");
    GFX_DOOR_OPEN = LoadGFX("fg_door_open.bmp");
    GFX_SWITCH_RED = LoadGFX("fg_switch_red.bmp");
    GFX_SWITCH_GREEN = LoadGFX("fg_switch_green.bmp");
	

    -- create door and switch
    OBJ_SWITCH = AddObject(GFX_SWITCH_RED, 1, 5, 0, 1, 0, 0);
    OBJ_DOOR = AddObject(GFX_DOOR_CLOSED, 23, 7, 1, 1, 1, 0);

   -- load extra sound
   SND_DOOR_OPEN = LoadSoundFX("fx_open_door.ogg");
   SND_DOOR_CLOSE = LoadSoundFX("fx_open_door.ogg");
   -- SND_DOOR_OPEN = LoadSoundFX("fx_collect_pixel.ogg");
   -- SND_DOOR_CLOSE = LoadSoundFX("fx_collect_pixel.ogg");

	-- Create elevator
    GFX_ELEVATOR[1] = LoadGFX("elevator2.bmp");
    GFX_ELEVATOR[2] = LoadGFX("elevator1.bmp");
    OBJ_ELEVATOR = AddObject(GFX_ELEVATOR[1], 43, 12, 1, 1, 0, 0);
	
end

-- Required function: Physics-loop for scripting part
function scriptPhysics ()
    if switchon == 1 then
        -- Block the door after a certain time
        timer = timer - 1;
        if timer == 0 then
            closeDoor();
        end
    end

	-- Elevator display
	ELEVATOR_TIMER = ELEVATOR_TIMER + 1;
	if ELEVATOR_TIMER == 50 then
		SetGFX(OBJ_ELEVATOR, GFX_ELEVATOR[2]);
	end
	if ELEVATOR_TIMER == 150 then
		SetGFX(OBJ_ELEVATOR, GFX_ELEVATOR[1]);
		ELEVATOR_TIMER = 0;
	end

	-- Elevator physics
	ELEVATOR_POS = ELEVATOR_POS + ELEVATOR_DIR;
	if ELEVATOR_POS == 64 or ELEVATOR_POS == 384 then
		ELEVATOR_DIR = ELEVATOR_DIR * -1;
	end
	SetObjPos(OBJ_ELEVATOR, 1376, ELEVATOR_POS);
	
end

-- Required function: Callback on "Action"-Button on FG-Objects
function handleAction (obj_id)
    -- Open door if not open
    if obj_id == OBJ_SWITCH and switchon == 0 then
        openDoor();
    end
end

-- Script-internal functions
function openDoor()
    switchon = 1;

    -- exchange GFX for door and button
    SetGFX(OBJ_SWITCH, GFX_SWITCH_GREEN);
    SetGFX(OBJ_DOOR, GFX_DOOR_OPEN);

    -- make door nonblocking
    SetBlocking(OBJ_DOOR, 0);
    timer = 500; -- 5 secs    

   -- play sound
   PlaySoundFX(SND_DOOR_OPEN);
end

function closeDoor()
    switchon = 0;

    -- exchange GFX for door and button
    SetGFX(OBJ_SWITCH, GFX_SWITCH_RED);
    SetGFX(OBJ_DOOR, GFX_DOOR_CLOSED);

    -- Block the door again
    SetBlocking(OBJ_DOOR, 1);

   -- play sound
   PlaySoundFX(SND_DOOR_CLOSE);
end
