-- Exercise scripting a bit in our test-level

-- write out that we loaded sucessfully (mor or less, anyway)
io.write("Starting script for Level0 in BlinkenLUA / ",_VERSION,"!\n")

-- declare some global variables
switchon = 0;
antigravShown = 1;
antigravTimer = 50;
GFX_ANTIGRAV = {};
GFX_SWITCH_RED = 0;
GFX_SWITCH_GREEN = 0;
OBJ_SWITCH = 0;
OBJ_ANTIGRAV = 0;

-- Required function: Initializing the level
function initLevel ()
    -- preload all gfx (on-the-fly loading is NOT recommended)
    GFX_SWITCH_RED = LoadGFX("fg_switch_red.bmp");
    GFX_SWITCH_GREEN = LoadGFX("fg_switch_green.bmp");
	

    -- create door and switch
    OBJ_SWITCH = AddObject(GFX_SWITCH_RED, 112, 11, 0, 1, 0, 0);

    -- load extra sound
    SND_DOOR_OPEN = LoadSoundFX("fx_open_door.ogg");
    SND_DOOR_CLOSE = LoadSoundFX("fx_open_door.ogg");

    -- Antigrav 
    GFX_ANTIGRAV[1] = LoadGFX("level8_antigrav1.jpg");
    GFX_ANTIGRAV[2] = LoadGFX("level8_antigrav2.jpg");
    GFX_ANTIGRAV[3] = LoadGFX("level8_antigrav3.jpg");
    GFX_ANTIGRAV[4] = LoadGFX("level8_antigrav4.jpg");
    GFX_ANTIGRAV[5] = GFX_ANTIGRAV[3];
    GFX_ANTIGRAV[6] = GFX_ANTIGRAV[2];
    OBJ_ANTIGRAV = AddObject(GFX_ANTIGRAV[1], 6, 12, 0, 0, 0, 0);

end

-- Required function: Physics-loop for scripting part
function scriptPhysics ()
    if switchon == 1 then
		x = GetPlayerX();
		y = GetPlayerY();
		if x > 192 and x < 3040 and y > 384 and y < 640 then
			SetFreeMovement(1);
		else
			SetFreeMovement(0);
		end
		antigravTimer = antigravTimer - 1;
		if antigravTimer == 0 then
			antigravTimer = 20;
			antigravShown = antigravShown + 1;
			if antigravShown == 7 then
				antigravShown = 1;
			end
			SetGFX(OBJ_ANTIGRAV, GFX_ANTIGRAV[antigravShown]);
		end
    end

end

-- Required function: Callback on "Action"-Button on FG-Objects
function handleAction (obj_id)
    -- Open door if not open
    if obj_id == OBJ_SWITCH then
		switchon = 1 - switchon;
		if switchon == 1 then
			SetGFX(OBJ_SWITCH, GFX_SWITCH_GREEN);
		    PlaySoundFX(SND_DOOR_OPEN);
			SetVisible(OBJ_ANTIGRAV, 1);
		else
			SetGFX(OBJ_SWITCH, GFX_SWITCH_RED);
		    PlaySoundFX(SND_DOOR_CLOSE);
			SetVisible(OBJ_ANTIGRAV, 0);
		end
    end
end
