// BlinkGame - Hunt for the Lost Pixels
// an SDL game in honor of the BlinkenArea crew
//
// (C) 2005-06 Rene Schickbauer, Wolfgang Dautermann
//
// See License.txt for licensing information
//


#include "globals.h"
#include "debug.h"
#include "showtext.h"

Uint32 fpsLastTick;
Uint32 fpsFrameCount;
Uint32 fpsLastFrameCount;
char fpsText[20];

void initFPSCounter() {
	fpsLastTick = SDL_GetTicks() + 1000;
	fpsFrameCount = 0;
	fpsLastFrameCount = 0;
	sprintf(fpsText, "FPS:");
}

void displayFPSCounter() {
	Uint32 tick = SDL_GetTicks();
	fpsFrameCount++;
	if(fpsLastTick < tick) {
		fpsLastFrameCount = fpsFrameCount;
		fpsFrameCount = 0;
		fpsLastTick = tick + 1000;
		sprintf(fpsText, "FPS: %d", fpsLastFrameCount);
	}
	drawstring(550,460,fpsText, gScreen);
}
		
