// BlinkGame - Hunt for the Lost Pixels
// an SDL game in honor of the BlinkenArea crew
//
// (C) 2005-06 Rene Schickbauer, Wolfgang Dautermann
//
// See License.txt for licensing information
//


#ifndef FGOBJECTS_H
#define FGOBJECTS_H

typedef struct _FGOBJS {
	bool isBlocking;
	bool isVisible;
	bool isOnTop;
	bool isKilling;
	bool isPixel;
	bool isElevator;
	Uint32 gfxobj;
	Sint32 x;
	Sint32 y;
	Sint32 last_y;
} FGOBJS;

typedef struct _FGOVERLAP {
	Sint32 left;
	Sint32 right;
	Sint32 bottom;
	Sint32 top;
} FGOVERLAP;
extern FGOVERLAP fgOverlap;

void initFGObjs();
void deInitFGObjs();
Uint32 addFGObjGFX(char *fname);
Uint32 addFGObj(Uint32 gfxobj, Uint32 x, Uint32 y, bool isBlocking, bool isVisible, bool isOnTop, bool isKilling);
void paintSingleFGObj(SDL_Surface *gfx, Sint32 x, Sint32 y);
void paintFGObjs(Uint32 xoffs, Uint32 yoffs, bool topObjects);
void doFGPlayerAction(Uint32 playerx, Uint32 playery);
void setFGObjSetVisible(Uint32 obj, bool visible);
void setFGObjSetBlocking(Uint32 obj, bool blocking);
void setFGObjSetOnTop(Uint32 obj, bool ontop);
void setFGObjSetElevator(Uint32 obj, bool elevator);
void setFGObjSetGFX(Uint32 obj, Uint32 gfx);
void setFGObjSetKilling(Uint32 obj, bool killing);
void setFGObjSetPixel(Uint32 obj, bool pixel);
void setFGObjSetPos(Uint32 obj, Uint32 x, Uint32 y);

void handlePlayerFGColission();
bool getPlayerFGKillColission();
void handlePlayerFGPixelCollission();
bool checkPlayerFGTrueCollission(Uint32 objid);
void handlePlayerFGTrueCollission();

extern Uint32 fgobjcnt;
extern Uint32 fgobjgfxcnt;
extern SDL_Surface *FGOBJ_Surface[];
extern FGOBJS fgObjs[];
extern FGOVERLAP fgOverlap;

#endif // FGOBJECTS_H
