// BlinkGame - Hunt for the Lost Pixels
// an SDL game in honor of the BlinkenArea crew
//
// (C) 2005-06 Rene Schickbauer, Wolfgang Dautermann
//
// See License.txt for licensing information
//


#ifndef LEVELHANDLER_H
#define LEVELHANDLER_H

// include the monster-handler here because we need the monster structure
#include "monstersprites.h"

struct DISPLAYLIST {
	Uint32 type;
	Uint32 x;
	Uint32 y;
	DISPLAYLIST* next;
};

typedef enum _PIXELSTYPE {
	PIXELTYPE_NONE = 0,
	PIXELTYPE_PIXEL,
	PIXELTYPE_LIVE,
	PIXELTYPE_POINTS,
	PIXELTYPE_POWER,
	PIXELTYPE_RESPAWN
} PIXELTYPE;
	

struct LEVELHANDLER {
	Uint32 leveltime;
	char bgfile[MAX_STRING_LENGTH];
	char bg2file[MAX_STRING_LENGTH];
	char sndfile[MAX_STRING_LENGTH];
	char tilesfile[MAX_STRING_LENGTH];
	char leveldata[MAX_STRING_LENGTH];
	char scriptfile[MAX_STRING_LENGTH];
	Uint32 height;
	Uint32 width;
	Uint32 numBlocks;
	Uint32 numPixels;
	Uint32 start_x;
	Uint32 start_y;
	Uint32 respawn_x;
	Uint32 respawn_y;
	Uint32 goal_x;
	Uint32 goal_y;
	DISPLAYLIST* dlist;
	DISPLAYLIST* pixels;
	MONSTERS* monsters;
	bool hasScript;
	bool hasBG2;
	bool hasMagicTiles;
	Uint32 magicTileSource;
	Uint32 magicTileDestination;
	Uint32 numMonsters;
	bool* tiles2d;	
};

extern LEVELHANDLER lhandle;

void initLevel(Uint32 level);
void deInitLevel();
void addPixel(Uint32 x, Uint32 y, Uint32 pixeltype);
void incrementMaxPixels(Uint32 count);
void paintLevelPixels(Uint32 xoffs, Uint32 yoffs, Uint32 blinkbright);
bool checkForTile(Sint32 x, Sint32 y);
void initTiles2D();

#endif // LEVELHANDLER_H
