// BlinkGame - Hunt for the Lost Pixels
// an SDL game in honor of the BlinkenArea crew
//
// (C) 2005-06 Rene Schickbauer, Wolfgang Dautermann
//
// See License.txt for licensing information
//


#ifndef MONSTERSPRITES_H
#define MONSTERSPRITES_H

#include "globals.h"

struct MONSTERAI {
	Uint32 lastTurnTick;
};

struct MONSTERS {
	Uint32 type;
	Uint32 startx;
	Uint32 starty;
	double monsterx;
	double monstery;
	double monstervx;
	double monstervy;
	double maxspeed;
	bool isAlive;
	bool isDying;
	bool seePlayer;
	bool mustStop;
	Uint32 dyeCount;
	Uint32 score;
	Uint32 spritenum;
	Uint32 spritetick;
	MOVE_TYPE mtype;
	MOVE_TYPE newmtype;
	MONSTERAI ai;
	MONSTERS* next;
};

extern bool hasEatenPixel;

void loadMonsterSprites();
void unloadMonsterSprites();
void addMonster(Uint32 type, Uint32 x, Uint32 y);
void initMonsters();
void freeMonsters();
void blitMonsterSprite(Sint32 x, Sint32 y, SDL_Surface* src, Uint32 srcoffs, Uint32 maxheight);
void showMonsterSprites(Uint32 screenXoffs, Uint32 screenYoffs);
void monsterPhysics(Uint32 playerx, Uint32 playery);

#endif // MONSTERSPRITES_H

